/*
 *	strtoull.c: part of libmissing(missing functions library)
 *	Copyright  1994  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include <stdlib.h>
#include <errno.h>
#include <limits.h>


#ifdef	uchar
#undef	uchar
#endif
#define	uchar	unsigned char

/* Functions */
unsigned long long strtoull (const char *str, char **end, int base)
{
	int c, cn;
	int shift;
	int sign, over;
	int	lm_rem;
	unsigned long long lm_quot;
	unsigned long long val;
	const char *top, *save;

	/* base `FbN */
	if (!(base == 0 || (2 <= base && base <= 36))) {
		errno = EINVAL;
		return 0;
	}

	/* top ۑ */
	top = str;

	/* 擪̋󔒂΂ */
	while ((uchar)(c = *str++) == (uchar)' ' || (uchar)(c - '\t') <= (uchar)('\r'-'\t')) ;

	/* ʏ͐ */
	sign = 0;

	/*  */
	switch (*--str) {
	case '-':
		sign = 1;
		/*NO BREAK*/
	case '+':
		str++;	/* XLbv */
		break;
	}

	/* 擪Ǝ̕tFb` */
	(uchar)c  = (uchar)str[0];
	(uchar)cn = (uchar)(str[1] | 0x20);	/* ɂ */

	/* base  */
	if (base == 0) {

		/* 擪 0 ? */
		if ((uchar)c == (uchar)'0') {
			/* ̕ x,X Ȃ 16 i */
			if ((uchar)cn == (uchar)'x') {
				base = 16;
				str += 2;
			}
#ifdef	ACCEPT_BINARYVALUE
			/* ̕ b,B Ȃ 16 i */
			else if ((uchar)cn == (uchar)'b') {
				base = 2;
				str += 2;
			}
#endif	/*ACCEPT_BINARYVALUE*/
			/* ႤȂ 8 i */
			else {
				base = 8;
			}
		}
		/* ႤȂ 10 i */
		else
			base = 10;
		}

	/* 肸݂ 16 iȂ 0x ΂ */
	else if ((uchar)base == (uchar)16) {
		if ((uchar)c == (uchar)'0' && (uchar)cn == (uchar)'x') str += 2;
	}
#ifdef	ACCEPT_BINARYVALUE
	/* 肸݂ 2 iȂ 0b ΂ */
	else if ((uchar)base == (uchar)2) {
		if ((uchar)c == (uchar)'0' && (uchar)cn == (uchar)'b') str += 2;
	}
#endif	/*ACCEPT_BINARYVALUE*/

	/* lϊJn̑OɂƏ */
	val = 0ULL;
	over = 0;
	save = str;

	/* VtgZł`FbN */
	shift = 0;

	/* switch ̓Wve[ũTCY傫Ȃ */
	if ((uchar)base == (uchar)16) {
		shift =  4;
	}
	else if ((uchar)base == (uchar)8) {
		shift =  3;
	}
	else if ((uchar)base == (uchar)4) {
		shift =  2;
	}
	else if ((uchar)base == (uchar)2) {
		shift =  1;
	}
	else if ((uchar)base == (uchar)32) {
		shift =  5;
	}

/*
	(val > (ULONGLONG_MAX - c) / base)

	ULONGLONG_MAX = lm_quot*base + lm_rem Ƃ
	(ULONGLONG_MAX - c)/base = lm_quot + (lm_rem - c)/base ƂȂ

	0 <= lm_rem, c < base Ȃ̂ -base < lm_rem - c < base ł
	ɂȂ̂ -base < lm_rem - c < 0 ̎

	 lm_rem < c  Ȃ̂ŁAŏ͈̎ȉ̂悤ɕό`

	(val > lm_quot - (lm_rem < c ? 1 : 0))

*/
	if (shift) {
		lm_rem  = (unsigned long)ULONGLONG_MAX & ((1<<shift)-1);
		lm_quot = ULONGLONG_MAX >> shift;
	}
	else {
		lm_rem  = ULONGLONG_MAX % base;
		lm_quot = ULONGLONG_MAX / base;
	}

	/* lϊ */
	while (c = *(uchar*)str) {

#ifdef	SKIP_UNDERSCORE
		/* `_' XLbv鏈 */
		if ((uchar)c == (uchar)'_') {
			str++;
			continue;
		}
#endif	/*SKIP_UNDERSCORE*/

		/* 0-9,a-z,A-Z  */
		if ((uchar)(c -= '0') > (uchar)('9' - '0')) {
			if ((uchar)(c -= 'A' - '0') <= (uchar)('Z' - 'A')
			||  (uchar)(c -= 'a' - 'A') <= (uchar)('z' - 'a')) {
				c += 10;
			}
			else {
				break;
			}
		}

		/* base `FbN */
		if ((uchar)c >= (uchar)base) break;

		/* I[o[t[`FbN */
		if (over == 0) {

			/* l`FbN */
			if (val > (lm_rem < c ? lm_quot - 1 : lm_quot)) {
				val = ULONGLONG_MAX;
				errno = ERANGE;
				over = 1;
			}
			else {
				/* XV */
				val = (shift ? val<<shift : val*base);
				val += c;
			}
		}

		/* is */
		str++;

	}

	/* |C^ݒ (萔Ȃꍇ͐擪̃AhXԂ) */
	if (end) *end = (char *) ((str == save) ? top : str);

    /* I */
    return sign ? ULONGLONG_MAX - val + 1 : val;
}
