#include	<stdio.h>
#include	<time.h>

#ifndef	MPU
#define	MPU	68000
#endif
#if	MPU >= 68020
#define	COUNT	10000
#else
#define	COUNT	1000
#endif

#define	LMAX	   "2147483647"
#define ULMAX	   "4294967295"

#define	HLMAX	   "7fffffff"
#define HULMAX	   "ffffffff"

#define LLMAX	    "9223372036854775807"
#define ULLMAX	   "18446744073709551615"

#define	HLLMAX	   "7fffffffffffffff"
#define HULLMAX	   "ffffffffffffffff"

extern long strtol(const char*, char**, int);
extern unsigned long strtoul(const char*, char**, int);

extern long long strtoll(const char*, char**, int);
extern unsigned long long strtoull(const char*, char**, int);

static clock_t _clock_start;

static clock_t clock_start(clock_t* ptr)
{
	if (ptr) return *ptr = clock();
	return _clock_start = clock();
}

static clock_t clock_stop(clock_t* ptr)
{
	if (ptr) return clock() - *ptr;
	return clock() - _clock_start;
}

void	main(void)
{
	int	i;

	clock_start(0);
	for (i = COUNT; --i >= 0;) {
		strtol(LMAX, 0, 10);
	}
	printf("  strtol(          \"%s\",0,10): %3d\n", LMAX, clock_stop(0));

	clock_start(0);
	for (i = COUNT; --i >= 0;) {
		strtol(HLMAX, 0, 16);
	}
	printf("  strtol(            \"%s\",0,16): %3d\n", HLMAX, clock_stop(0));

	clock_start(0);
	for (i = COUNT; --i >= 0;) {
		strtoul(ULMAX, 0, 10);
	}
	printf(" strtoul(          \"%s\",0,10): %3d\n", ULMAX, clock_stop(0));

	clock_start(0);
	for (i = COUNT; --i >= 0;) {
		strtoul(HULMAX, 0, 16);
	}
	printf(" strtoul(            \"%s\",0,16): %3d\n", HULMAX, clock_stop(0));

	clock_start(0);
	for (i = COUNT; --i >= 0;) {
		strtoll(LLMAX, 0, 10);
	}
	printf(" strtoll( \"%s\",0,10): %3d\n", LLMAX, clock_stop(0));

	clock_start(0);
	for (i = COUNT; --i >= 0;) {
		strtoll(HLLMAX, 0, 16);
	}
	printf(" strtoll(    \"%s\",0,16): %3d\n", HLLMAX, clock_stop(0));

	clock_start(0);
	for (i = COUNT; --i >= 0;) {
		strtoull(ULLMAX, 0, 10);
	}
	printf("strtoull(\"%s\",0,10): %3d\n", ULLMAX, clock_stop(0));

	clock_start(0);
	for (i = COUNT; --i >= 0;) {
		strtoull(HULLMAX, 0, 16);
	}
	printf("strtoull(    \"%s\",0,16): %3d\n", HULLMAX, clock_stop(0));
}

